(in-package :docu)

;;UNITS=====================================================
;;
;; This am_customize file was designed to run with the units
;;  lenght : 1 mm and angle: 1 degree / SD default units will be saved
(remember-user-units)
(units 1 :mm) (units 1 :deg)
;; using other units will require to adjust all commands
;;  using values having a unit.
;;
;; Don't forget to adjust the UNITS command in the last line
;; to your preferred values when they should differ from SD default units

;;Customization function to define VIEW PROFILES used within the
;;view creation commands and update
;; (docu-clear-view-profiles)
;; resets all defined view profiles
;;
;; (docu-register-view-profile 
;; defines standard profiles for all types of views
;; :name                           "Unique profile name" 
;; :label                          "This name is displayed in the UI"
;; :minimum-number-of-parts        100  ;; if these two keywords are not specified then the profile will
;; :maximum-number-of-parts        1000 ;; never be selected by default, but can be selected 
                                        ;; within the user interface.
                                        ;; if there are more than 1 profile with the same number-of-parts
                                        ;; settings the LAST one is selected automatically (see profile
                                        ;; 'Complex Simple' and 'Simple Single' below).
;; :update-mode                    :graphics ;; or :classic 
;; :facet-accuracy                 :medium   ;; or :low, :high, :current
;; :econofast                      :on ;; or :off or :default 
;; :associativity-2d               :full ;; or :limited
;; :pressfit-handling              :on   ;; or :off or :default
;; :clash-recognition                 :off  ;; or :on  or :default
;; :remove-small-parts             0 ;; or any percentage number, ie 1.0 
;; :remove-library-parts           :on ;; or off 
;; :remove-full-circles            0 ;; or any threshold value, ie. 0.5 
;; :remove-duplicate-hidden-lines  :on ;; or :off 
;; :thread-creation                :on ;; or :off, :default or :parent (for detail & section)
;; :centerline-creation            :on ;; or :off, :default or :parent (for detail & section)
;; :symmetryline-creation          :on ;; or :off, :default or :parent (for detail & section)
;; :hidden-line-visible            :on ;; or :off, :default or :parent (for detail & section)
;; :tangent-line-visible           :on ;; or :off, :default or :parent (for detail & section)
;; )
;;
;; (docu-register-exception-profile
;; defines global settings for specific view types
;; :name                           "Unique profile name"
;; :label                          "This name is displayed in the UI"
;; :minimum-number-of-parts        1
;; :maximum-number-of-parts        999999
;; :view-type                      :standard ;; or :all, :section, :detail, :general
;;                                              or a list of view-types like (list :standard :general)
;; :update-mode                    :graphics ;; or :classic
;; :facet-accuracy                 :medium   ;; or :low, :high, :current
;; :econofast                      :on ;; or :off or :default
;; :associativity-2d               :full ;; or :limited
;; :pressfit-handling              :on   ;; or :off or :default
;; :clash-recognition              :off  ;; or :on  or :default
;; :remove-small-parts             0 ;; or any percentage number, ie 1.0
;; :remove-library-parts           :on ;; or off
;; :remove-full-circles            0 ;; or any threshold value, ie. 0.5
;; :remove-duplicate-hidden-lines  :on ;; or :off
;; :thread-creation                :on ;; or :off, :default or :parent (for detail & section)
;; :centerline-creation            :on ;; or :off, :default or :parent (for detail & section)
;; :symmetryline-creation          :on ;; or :off, :default or :parent (for detail & section)
;; :hidden-line-visible            :on ;; or :off, :default or :parent (for detail & section)
;; :tangent-line-visible           :on ;; or :off, :default or :parent (for detail & section)
;; )

(docu-clear-view-profiles)

(docu-register-view-profile
  :name                           "Complex Single"
  :label                          "Singolo Complesso"
  :minimum-number-of-parts        1
  :maximum-number-of-parts        1
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :on
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)

(docu-register-view-profile
  :name                           "Simple Single" ;; same as 'Complex Single' but
                                                  ;; :update-view-immediately :on
  :label                          "Singolo Semplice"
  :minimum-number-of-parts        1
  :maximum-number-of-parts        1
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        '(:by_faces 300)
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :on
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)


(docu-register-view-profile
  :name                           "Small"
  :label                          "Piccolo Gruppo"
  :minimum-number-of-parts        2
  :maximum-number-of-parts        99
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :default
  :clash-recognition              :default
  :update-view-immediately        :on
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :default
  :centerline-creation            :default
  :symmetryline-creation          :default
  :hidden-line-visible            :on
  :tangent-line-visible           :default
)

(docu-register-view-profile
  :name                           "Medium"
  :label                          "Gruppo Medio"
  :minimum-number-of-parts        100
  :maximum-number-of-parts        500
  :update-mode                    :graphics
  :facet-accuracy                 :medium
  :associativity-2d               :limited
  :pressfit-handling              :default
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-profile
  :name                           "Large"
  :label                          "Gruppo Grande"
  :minimum-number-of-parts        501
  :maximum-number-of-parts        999999
  :update-mode                    :graphics
  :facet-accuracy                 :low
  :associativity-2d               :limited
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             1.0
  :remove-library-parts           :on
  :remove-full-circles            0.5
  :remove-duplicate-hidden-lines  :on 
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-profile 
  :name                           "NC" 
  :label                          "NC"
  :update-mode                    :classic 
  :econofast                      :off 
  :associativity-2d               :full
  :pressfit-handling              :on
  :clash-recognition              :default
  :update-view-immediately        :on
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off 
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-exception-profile 
  :name                           "Section" 
  :label                          "Sezione"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :section
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)

(docu-register-view-exception-profile 
  :name                           "Detail" 
  :label                          "Dettaglio"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :detail
  :centerline-creation            :parent
  :symmetryline-creation          :parent
  :thread-creation                :parent
  :hidden-line-visible            :parent
  :tangent-line-visible           :parent
)

(docu-register-view-exception-profile 
  :name                           "Broken"
  :label                          "Interruzione"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :broken
  :centerline-creation            :on
  :symmetryline-creation          :on
  :thread-creation                :parent
  :hidden-line-visible            :parent
  :tangent-line-visible           :parent
)

(docu-register-view-exception-profile
  :name                           "Isometric Small" 
  :label                          "Isometric Small"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :general
  :centerline-creation            :off
  :symmetryline-creation          :off
  :thread-creation                :off
)

(docu-register-view-exception-profile 
  :name                           "Isometric Large" 
  :label                          "Isometric Large"
  :minimum-number-of-parts        10
  :maximum-number-of-parts        999999
  :view-type                      :general
  :update-mode                    :graphics
  :facet-accuracy                 :low
)

;;; *** Annotation View Settings ***
;;; *** Annotation View Settings : Normal Lines ***     DIN/ISO 128-20 & -24
;;; *** Annotation View Settings : Hidden Lines ***
;;; *** Annotation View Settings : Tangential Lines ***

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The following section define the labels for details, partials and cutaways
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; The following section define the labels below standard, flat and general views




;;; *** Annotation Hatch Settings : Mode ***
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(am_mbp_settings
  :circle_size  1.0
  :circle_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :circle_linetype :PHANTOM
  :circle_pensize  0.0
  :lines_size   1.5
  :lines_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :lines_linetype :SOLID
  :lines_pensize 0.0
  :extension_color (oli::sd-rgb-to-color 1.0,0.0,1.0) :done
  :extension_linetype :PHANTOM
  :extension_pensize 0.0
  :lost_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :automatic_update
)
(docu::docu-reset-drawing-modified-flag)



;;; *** Annotation Text Settings ***

;;UNITS=====================================================
;; reset to SD default units
(restore-user-units)


(display "*** Caricamento completato senza errori (USER COMMON LISP)***")
