(in-package :docu)

;;UNITS=====================================================
;;
;; This am_customize file was designed to run with the units
;;  lenght : 1 mm and angle: 1 degree / SD default units will be saved
(remember-user-units)
(units 1 :mm) (units 1 :deg)
;; using other units will require to adjust all commands
;;  using values having a unit.
;;
;; Don't forget to adjust the UNITS command in the last line
;; to your preferred values when they should differ from SD default units

;;--------(docu::docu-create-drawing-behaviour :view_placement :first_angle)

;;DEFAULT===================================================

(config-section 
 :docu_section_line_geo_size         '0.25

 :docu_section_line_segm_mode        'SEGM_OVERLAP ;;or 'NONE
                                                   ;;   'SEGM_OVERLAP
 :docu_section_line_segm_length      '5.0
 :docu_section_line_segm_size        '0.5
 :docu_section_line_leader_mode      'LEADER_TO   ;;or 'LEADER_FROM
 :docu_section_line_leader_length    '10.0
 :docu_section_line_leader_size      '0.35
 :docu_section_line_leader_arr_size  '3.5 ;;'10.5
 :docu_section_line_leader_arr_type  'ARROW_TYPE    ;;or 'DOT_TYPE
                                                    ;;   'SLASH_TYPE
                                                    ;;   'TRIANGLE_TYPE
                                                    ;;   'JIS_TYPE
 ;; The following settings define the label on each side of the
 ;; section line
 :docu_section_line_label_offset     '7.0
 :docu_section_line_label_position   'TOP_SIDE  ;;or 'BOTTOM_SIDE 
                                                  ;;   'TOP
 :docu_section_line_label_size       '5.0
 :docu_section_line_label_slant      '0.0
 ;; The following settings define the label below the section view
 :docu_section_view_label_prefix     ""
 :docu_section_view_label_offset     '5.0
 :docu_section_view_label_size       '5.0
 :docu_section_view_label_slant      '0.0
)

;; The following section define the labels for details, partials and cutaways
(config-detail 
 ;;The following settings define the detail/cutaway border
 :docu_detail_border_size                  '0.25

 ;; The following settings define the label below the detail/cutaway border
 :docu_detail_label_offset                '5.0
 :docu_detail_label_size                  '3.5
 :docu_detail_label_slant                 '0.0
 :docu_detail_label_border_prefix         "A"

 ;; The following settings define the label below the detail/partial view 
 :docu_detail_view_label_offset                '5.0
 :docu_detail_view_label_size                  '3.5
 :docu_detail_view_label_slant                 '0.0
 ;; The following settings define the appearance of the border elements
 ;; within the detail /partial view 
 :docu_detail_border_edge_size                 '0.25
 :docu_partial_border_edge_size                '0.25
 :docu_cutaway_border_edge_size                '0.25
 :docu_broken_border_edge_size                 '0.25

 :docu_broken_border_edge_pattern_width        3.0
 :docu_broken_border_edge_pattern_height       2.0
 :docu_broken_view_inner_gap                   10.0
)

;; The following section define the labels below standard, flat and general views
(config-view-labels
 :docu_view_label_offset                '5.0
 :docu_view_label_size                  '3.5
 :docu_view_label_slant                 '0.0
 :docu_view_label_frame                 'OFF
 ;;:docu_view_label_text_case :upper   ;; :normal / :lower / :off NON PERMESSO DA PE
 :docu_view_label_text_for_front_view   "fronte"
 :docu_view_label_text_for_back_view    "retro"
 :docu_view_label_text_for_right_view   "da destra"
 :docu_view_label_text_for_left_view    "da sinistra"
 :docu_view_label_text_for_top_view     "pianta"
 :docu_view_label_text_for_bottom_view  "dal basso"
 :docu_view_label_text_for_iso_view     "Isometrica"
 :docu_view_label_text_for_gen_view     "Generica"
)

(config-scale-info-within-view-labels
 :docu_view_label_scaling_prefix        ""
)

;; *************************************************************
;; WorkManager - Annotation Link customization
;; please add customizations for the WorkManager - Annotation Link
;; to the file "am_wm_customize"
;; *************************************************************

;;  (docu::docu-register-frame :ui-name "WM-A0" :wm-name "A0")
;;  (docu::docu-register-frame :ui-name "WM-A1" :wm-name "A1")
;;  (docu::docu-register-frame :ui-name "WM-A2" :wm-name "A2")
;;  (docu::docu-register-frame :ui-name "WM-A3" :wm-name "A3")
;;  (docu::docu-register-frame :ui-name "WM-A4" :wm-name "A4")

;;Example: Hatch Pattern Customization
;;Note: All values are taken in current units (also during hatch creation).

;(register-hatch-pattern
; :name        "Steel"
; :label       "Steel"
; :angle       45.0
; :distance    15.0
; :patternlist  `( ,(make-simple-pattern
;                   :offset     0.0
;                   :distance   1.0
;                   :angle      0.0
;                   :color      "CYAN"
;                   :line-type  "SOLID")
;                 ,(make-simple-pattern
;                   :offset     0.33333
;                   :distance   1.0
;                   :angle      0.0
;                   :color      "CYAN"
;                   :line-type  "SOLID")
;                  )
; )

;;Example: Frame registration
;(docu-register-frame 
;	:ui-name "Company-A0"
;	:wm-name "" 
;	:file "/tmp/Company-A0"
;	:default :everytime)     ;; T/NIL/:everytime

;;------------------------------REGISTRAZIONE FORMATI--------------------
(docu-unregister-frame-all)

(docu-register-frame 
	:ui-name "A4V-UP"
	:wm-name "" 
        :file "c:/Programmi/Cocreate/custom18/18.0/formati/A4V-UP.mi"
	:default :everytime)     ;; T/NIL/:everytime

(docu-register-frame 
	:ui-name "A4H-UP"
	:wm-name "" 
        :file "c:/Programmi/Cocreate/custom18/18.0/formati/A4H-UP.mi"
	:default :everytime)     ;; T/NIL/:everytime
(docu-register-frame 
	:ui-name "A3V-UP"
	:wm-name "" 
        :file "c:/Programmi/Cocreate/custom18/18.0/formati/A3V-UP.mi"
	:default :everytime)     ;; T/NIL/:everytime
(docu-register-frame 
	:ui-name "A3H-UP"
	:wm-name "" 
        :file "c:/Programmi/Cocreate/custom18/18.0/formati/A3H-UP.mi"
	:default :everytime)     ;; T/NIL/:everytime

;;--------------------------------- FINE REGISTRAZIONE FORMATI------------------------
;;Further frame related functions:
;(docu-unregister-frame "<ui-name>")
;(docu-unregister-frame-all)

;;-----------------------------------------------------------------------------
;; register standard frame sizes for recognition during migration (A..E,A0..A4)
;;-----------------------------------------------------------------------------
(docu-register-migr-frame-standard-sizes)

;;-----------------------------------------------------------------------------
;; predefined text reference groups and types for frame customization
;;-----------------------------------------------------------------------------
(docu-unregister-tr-group "Sheet_local")
(docu-register-tr-group   "Sheet_local"  "SHEET")
(docu-register-tr-type    "Sheet_local"  "SHEET_NO" "???" 
                          'docu::docu-get-current-sheet-name) 
(docu-register-tr-type    "Sheet_local"  "SHEET_SCALE" "???"
                          'docu::docu_inq_curr_sheet_scale_text)

(docu-unregister-tr-group "Sheet_global")
(docu-register-tr-group   "Sheet_global" "GLOBAL")
(docu-register-tr-type    "Sheet_global" "SHEETS"   "???" 
                          'docu::docu-inq-highest-sheet-name) 
(docu-register-tr-type    "Sheet_global" "DRAWING_NO"   "???"
                          'docu::docu_inq_drawing_number_text)

;;-----------------------------------------------------------------------------
;; automatically update text references for "current sheet" and "highest sheet"
;;-----------------------------------------------------------------------------
(oli::sd-unsubscribe-event "*DOCU-CHANGE-SHEET-DATA-EVENT*" 
                           'docu-update-sheet-info)

(defun docu-update-sheet-info ()
  (docu-update-tr-group "Sheet_local" )
  (docu-update-tr-group "Sheet_global")
)

(oli::sd-subscribe-event   "*DOCU-CHANGE-SHEET-DATA-EVENT*" 
                           'docu-update-sheet-info)


;;-----------------------------------------------------------------------------
;; To register additional Isometric modes:
;;-----------------------------------------------------------------------------
;(register-view :name "30"
;	        :x-rot 30
;	        :y-rot 60)
; current ISO mode is maintained automatically
;;-----------------------------------------------------------------------------

;; Example: Special Character

;(docu-register-special-char :char-code    126
;                            :font-code    :hp_symbols2
;                            :meta-name    "Micro"
;                            :pixmap-file  "pixmaps/doc3d2d/sym2_126.pm")

;(docu-register-special-char :char-code    63
;                            :font-code    :hp_symbols
;                            :meta-name    "Depth"
;                            :pixmap-file  "pixmaps/doc3d2d/sym_063.pm")

;;-----------------------------------------------------------------------------
;; Default Drawing Owner Strategy:
;;-----------------------------------------------------------------------------
(am_set_default_drawing_owner_strategy (list :last_owner :curr_assembly 
					     :top_part_assembly :curr_part
					     ;; 'user-function
					     ;; "/a1/p1"
					     ))
;; The default owner of a new drawing is determined according to the
;; parameters given in am_set_default_drawing_owner_strategy. 
;; The first criteria along the parameter sequence which successfully returns
;; a valid owner determines the default drawing owner, otherwise the next
;; criteria of the parameter list is considered.
;; The following criteria are possible:
;;  :last_owner         last used owner if still available
;;  :curr_assembly      parent assembly of the current part if not root "/"
;;  :top_part_assembly  first part or assembly on top level (alphabetically)
;;  :curr_part          current part if available
;;  'user-function      a user supplied function which needs to return
;;                      either a valid object (sel_item) or valid object string
;;  "/a1/p1"            a fixed object string

;;-----------------------------------------------------------------------------
;; Default Drawing Number Strategy:
;;-----------------------------------------------------------------------------
(am_set_default_drawing_number (list :selected_owner :curr_part :last_owner
				     :curr_assembly :top_part_assembly
				     ;; 'user-function
				     ;; "New Drawing"
				     ))
;; The default drawing number of a new drawing is determined according to the
;; parameters given in am_set_default_drawing_number. 
;; The first criteria along the parameter sequence which successfully returns
;; a valid string determines the default drawing number, otherwise the next
;; criteria of the parameter list is considered.
;; The following criteria are possible:
;;  :selected_owner     name of the selected drawing owner
;;  :curr_part          name of the current part if available
;;  :last_owner         name of the last used owner if still available
;;  :curr_assembly      name of the parent assembly of the current part if not
;;                      root "/" otherwise name of the current part
;;  :top_part_assembly  name of the first part or assembly on top level
;;                      (alphabetically ordered)
;;  'user-function      a user supplied function which needs to return a string
;;  "New Drawing"       a fixed string
;; Example of a user supplied function:
;;    (defun get_my_new_drawing_name ()
;;      (if (oli:sd-am-inq-drawing-selected-owner)
;;	    (oli:sd-string-upcase (oli:sd-inq-obj-basename 
;;                                 (oli:sd-am-inq-drawing-selected-owner)))
;;	   nil))
;;   (am_set_default_drawing_number (list 'get_my_new_drawing_name
;;                                        :curr_assembly "DWG Number"))

;;-----------------------------------------------------------------------------
;; Default Viewset Name Strategy:
;;-----------------------------------------------------------------------------
(am_set_default_viewset_name_strategy 
 (list :drawing-number-dot-sheet :drawing-number :owner-name
       ;; '(user-function owner dwg-num sheet)
       ;; "Fix Name" like "viewset"
       :default ;; => "vs1" ...
       ))
;; The default viewset name (automatically created during "Create Drawing" or
;; "Add View") is determined according to the parameters given in
;; am_set_default_viewset_name_strategy.
;; The first criteria along the parameter sequence which successfully returns
;; a valid string determines the default viewset name, otherwise the next
;; criteria of the parameter list is considered.
;; The following criteria are possible:
;;  :drawing-number-dot-sheet  viewset name is composed out of
;;                             "Drawing Number"."Sheet"
;;  :drawing-number            viewset name is derived from drawing number
;;  :owner-name                viewset name is derived from owner name
;;  'user-function             a user supplied function which has to accept
;;                             three parameters which are filled with the
;;                             selected owner (sel_item), the drawing number
;;                             (string) and the sheet number (string).
;;                             The function needs to return a string.
;;  "Fix Name"                 a fixed string
;;  :default                   the default name strategy "vs1", "vs2", ...

;;-----------------------------------------------------------------------------

(AM_SET_DEFAULT_DRAWING_SCALE 1)

;;-----------------------------------------------------------------------------

;;Example: Sketch un/registration functions (proper for Load Sketch command)
;unregister all sketches from the "Registered Sketches" table
;(docu-unregister-all-sketches)
;register an entry in the "Registered Sketches" table
;(docu-register-sketch :obj-name "Entry Name" :file-name "absolute path name of sketch")
;unregister an entry from the "Registered Sketches" table
;(docu-unregister-sketch "Entry Name")

;;-----------------------------------------------------------------------------
;; Common Owner
;;-----------------------------------------------------------------------------
;; Set all owner groups :geo :c-geo :text :symbol :sketch to one owner group:
(docu-set-common-owner :all)
;; Set two common owner groups for geo/c-geo and text/symbol
;; (docu-set-common-owner '((:geo :c-geo) (:text :symbol)))
;; Reset common owner specification  (behaviour of version <7.0)
;; (docu-set-common-owner nil)

;;----------------------------------------------------------------------------
;; With the help of the following function it's possible to change the
;; default color and linetype that is used for highlighting selected elements
;;
;;(AM_VIEWPORT_COLOR :HIGHLIGHT_COLOR :RGB 1,0,0 :DONE :HIGHLIGHT_ATTR :DASHED)
;;
;; When activating the above function, all selected elements will be highlighted
;; in RED color and with a dashed linetype.

;;----------------------------------------------------------------------------
;; With the help of the following functions it's possible to change the
;; default color for flyby highlighting
;;
;; (oli::sd-execute-annotator-command :cmd "FLYBY_SELECT_COLOR RGB_COLOR 1.00,0.65,0.00") ; orange
;; (oli::sd-execute-annotator-command :cmd "FLYBY_HANDLE_COLOR RGB_COLOR 0.72,0.23,0.56") ; plum
;; (oli::sd-execute-annotator-command :cmd "FLYBY_DRAG_COLOR   RGB_COLOR 0.89,0.89,0.98") ; lavender
;;
;; When executing the commands above, elements highlighted for selection will be
;; highlighted in orange color. Elements which could be modified by handles will
;; be highlighted with plum color, when not in preselection. Elements which could
;; be dragged to other position, will be highlighted WITH lavender color when not
;; in the preselection.

;;----------------------------------------------------------------------------
;; Following functions allow to change appearance of handles.
;;
;; (oli::sd-execute-annotator-command :cmd "MH_PEN_COLOR  RGB_COLOR 0.00,1.00,1.00") ; cyan
;; (oli::sd-execute-annotator-command :cmd "MH_FILL_COLOR RGB_COLOR 0.00,0.00,1.00") ; blue
;; (oli::sd-execute-annotator-command :cmd "MH_SIZE 3") ; in pixels, allowed number between 1 and 10
;;
;; Commands above will set size of handles to 3. The handle box will be drawn
;; in cyan color and filled with blue color.

;;----------------------------------------------------------------------------
;; Functions below allows to change behaviour and appearance of copilot last
;; visited points
;;
;; (oli::sd-execute-annotator-command :cmd "UA_SNAP_POINTS_COLOR RGB_COLOR 0.00,1.00,0.00") ; green
;; (oli::sd-execute-annotator-command :cmd "UA_SNAP_POINTS_COUNT 5")
;; (oli::sd-execute-annotator-command :cmd "UA_SET_SNAP_POINTS_DELAY 0.3") ; 0.3 s
;;
;; Executing commands above will define that last visited points have to be
;; displayed in green color and that they have to appear after waiting on the
;; element end point for 0.3 s. Maximum number of last visited points would
;; be 5.

;;----------------------------------------------------------------------------
;; With help of the following commands, appearance of the copilot snap lines
;; between last visited points and snap points is determined.
;;
;; (oli::sd-execute-annotator-command :cmd "UA_SNAP_LINES_COLOR RGB_COLOR 0.00,1.00,0.00") ; green
;; (oli::sd-execute-annotator-command :cmd "UA_SNAP_LINES_TYPE CENTER_DASH_DASH")
;;
;; Activating functions above would change the apperance of snap lines so that
;; they would be green and of specified linetype.

;;----------------------------------------------------------------------------
;; Following functions determine appearance of copilot constraint signs which
;; are drawn when they are satisfied (parallel, perpedicula, tangent,..)
;;
;; (oli::sd-execute-annotator-command :cmd "UA_CONSTRAINT_SIGN ON") ; ON or OFF
;; (oli::sd-execute-annotator-command :cmd "UA_CONSTRAINT_SIGN_COLOR RGB_COLOR 1.00,1.00,0.00") ; yellow
;;
;; Functions above would turn the drawing of constraints on and they would be
;; drawn in yellow color.

;;----------------------------------------------------------------------------
;; Following functions determine appearance of copilot texts.
;;
;; (oli::sd-execute-annotator-command :cmd "UA_TEXT_BOX_BORDER ON") ; ON or OFF
;; (oli::sd-execute-annotator-command :cmd "UA_TEXT_LONG_PREFIX ON") ; ON or OFF
;; (oli::sd-execute-annotator-command :cmd "UA_TEXT_COLOR RGB_COLOR 1.00,1.00,1.00") ; white
;;
;; After executing the command above, border will be shown around the text,
;; long prefixes will shown before the text (example Diameter:10 instead of D:10)
;; and color of the text will be white.


;;-----------------------------------------------------------------------------
;; Example: Predefined Values
;;-----------------------------------------------------------------------------
(docu-set-predef-values  :docu :scale '(0.001 0.002 0.005 0.01 0.02 0.05 
					   0.1 0.2 0.5 1 2 5 10 20 50)) ;; ISO 5455
(docu-set-predef-values  :docu :angle '( :deg 0 15 30 45 60 90 135 180 225 270 315 360))
(docu-set-predef-values  :docu :line-width '( :mm 0.0 0.18 0.25 0.35 0.5 0.7 1.0 1.4)) ;; DIN 15

(docu-set-predef-values  :text :angle (list :deg 0 15 30 45 90 135 180 225 270 315 360))
(docu-set-predef-values  :text :size_abs (list :mm 1.8 2.5 3.5 5 7 10 14 20))  ;; ISO 3098
(docu-set-predef-values  :text :text  nil) ;; e.g. (list "Preliminary" "Confidential" "3D Model exist"))

(docu-set-predef-values  :symbol :angle    (list :deg 0 15 30 45 90 135 180 225 270 315 360))
(docu-set-predef-values  :symbol :size_abs (list :mm  2.5 3.5 5 7 10 14 20))  ;; ISO 3098
(docu-set-predef-values  :symbol :size_rel (list 0.25 0.35 0.5 0.7 1 1.43 2.0 2.86 4.0))

;(docu-set-predef-values  :copilot :distance (list 0.001 0.05 0.1 0.5 1 5 10 50 100)) ;; default is 1/2/5 stepping from 0.0001 to 50000)
;(docu-set-predef-values  :copilot :angle (list :deg 0.1 0.2 0.5 2 1 5 10 15 30 45 60 90))

;; Example: control the capability of the Grab command
;(docu-selected-settings-single-selection-auto-grab :on)  ;;(:on/:off)

;; Example: disable/enable setting of pen- or linesize 
;(docu-set-pen-and-line-size-mode :both) 
;;(:both/:pensize_only/:linesize_only/:pensize_prefered/:linesize_prefered/:none) 

;; Example: Default behavior for delete/undelete
 (am_undelete_settings :del_previous)                     ;;(:del_nothing/:del_previous/:del_all)
;(am_undelete_settings :init_access_mode :sequential)     ;;(:selected/:sequential)
;;The following 2 settings, define whether 
;; a) Delete / Undelete can be canceled - or
;; b) Delete / Undelete works without clicking OK
;(am_undelete_settings :cancel_delete :on)                 ;;(:on/:off)
;(am_undelete_settings :cancel_undelete :on)                 ;;(:on/:off)


;; Example: Auxiliary Lines during creation of section views
;(am_tmp_auxiliary_lines_setting :enable :on)             ;;(:on/:off)
;(am_tmp_auxiliary_lines_setting :arc_included :on)       ;;(:on/:off)

;Set the default update mode
(am-set-update-mode :as_stored) ; or :normal or :econofast
(am-update-use-max-resolution-for-hardware-support t)
;(am-update-use-max-resolution-for-hardware-support nil)

;;;Set the default mode for transfer docuplane annotations
;;; can be :view :drawing :sheet :view-set
;(docu_set_default_type_for_transfer_docuplane_annotations :sheet)

;; Handling of recreated elements during view update
;(docu-cleanup-for-recreated-elements :delete :off    ;; (:ON/:OFF/:WARNING)
;                                     :reattach :off) ;; (:ON/:OFF)

;; Example: Enable/Disable the automatic update of associated elements like PRP's
; (enable-automatic-update-of-associated-elements :ON)  ;; (:ON/:OFF)

;; Example: Enable/Disable test for converting dim tolerance types
;(docu-enable-test-for-dim-conversion :ON)  ;; (:ON/:OFF)

; set highlight color for Transfering 3D Annos
(setq docu::*highlight-color-transfer-3D-annos* "RGB_COLOR 1,1,0")
(setq docu::*highlight-linetype-transfer-3D-annos* "SOLID")

;; the following function defines if new or copied parts are 
;; automatically added to the corresponding view sets.
;; There are 3 options: 
;;  :NO        <-> Parts / Assys are not added to the view sets automatically
;;                 (Standard behaviour of SD version 7.5 and lower).
;;  :ALWAYS    <-> Parts / Assys are automatically added to possible view sets.
;;  :AS_SOURCE <-> Parts / Assys are only added to the view set if the source 
;;                 part is a component of the view.
;; Example: Part /a1/p1 is component of view /a1/vs1/front1 but is not
;;          component of /a1/vs1/top1. When the part /a1/p1 is copied to
;;          /a1/p2, the new part is 
;;          o automatically added to view front1 and top1 with the 
;;            option :ALWAYS
;;          o automatically added to view front1 but not to the view top1
;;            with the option :AS_SOURCE
;;          o not automatically added to any view.

(add_parts_automatically_to_view_sets :new_parts :AS_SOURCE 
                                      :copied_parts :AS_SOURCE)

;; With the following setting you can define the behaviour of the command 
;; ADD PART and REMOVE PART:
;; With (add_remove_part_also_in_dependant_views t)
;; the selected part is added / removed to / from the specified views and all 
;; dependant views (section and detail views) too.
;; With (add_remove_part_also_in_dependant_views nil)
;; the selected part is just added / removed to / from the selected views.

(add_remove_part_also_in_dependant_views nil)


;; the following function defines the behaviour of font translation
;;   during file 2D data export
;;  input 
;;    mode        :to_geo | :to_text    alternative keywords
;;    font-list   (list of strings)     font name list
;;                or  :none  :all       empty list / all fonts
;;   when mode==:to_geo then all texts using listed fonts will
;;                            be converted to geometry
;;   when mode==:to_text then all texts NOT using listed fonts
;;                            will be converted to geometry
;;                            (the listed fonts will be kept)
;;   text_to_geometry_button
;;       :on / :off   define the default for related button
;;                      of export dialogs / option

(docu-define-export-fonts :to_geo :all)

;; There are two different possibilities how the UPDATE VIEW command
;; positions a detail view after the detail border was modified.
;; 
;; 1. The detail view doesn't change it's position.
;;    Advantage: No manual repositioning of the view is required
;;    Attention: Dependant views will always change their contents !
;;  
;; 2. The detail view get's positioned according to the detail border 
;;    modification, f.e. if the detail border gets moved horizontal by 50, then
;;    also the detail view gets moved by 50 in horizontal direction.
;;    Advantage: If the detail view was positioned next to the detail border,
;;                 then, after the update, the detail view is still next to the 
;;                 detail border
;;    Attention: The detail view may intersect with other views of the sheet
;;               
;; Setting name: (setq *docu_keep_detail_at_same_position* t / nil)
;; Default is:
;;   (setq *docu_keep_detail_at_same_position* nil) ;; replaced by following line:
(AM_DEFAULT_VIEW_POSITIONING :VIEW_CENTER) ;; :GEOMETRY/:VIEW_CENTER

;; Diameter dimensions get a dimension line with 2 arrows when the owning
;; element is a circle or an arc > 180 degrees. To always have a 2 arrow
;; dimension line for diameter dimensions outcomment to following line
;; (AM_DIM_SET_ARROW_LINE :BOTH_ARROW_DIA "ON")

;; By default the update dialog checks the up-to-date status of all views
;; of the drawing. This may take some minutes for very big drawings.
;; The following variable defines, if the checks are performed or not.
;; To disable the up-to-date checks uncomment the following line:
;; (setq docu::*docu-check-up-to-date* nil)

;; By default the UPDATE VIEW also updates all far base point dimensions
;; (refer to the EXTERNAL BASE POINT button within the coordinate dimension dialog)
;; If you do not use the external base point dimensions, set the varialbe below to 
;; 'nil' in order to increase the update performance
(setq docu::*docu-automatic-update-of-far-base-dimensions* t)

;; Not to see empty columns in the tables for dimension fix texts the following
;;  Integration Kit Function calls can be used
(oli::sd-filter-display-table "AM-PRE-FIX"   :column :Prefix   :test1 :greater :value1 " ")
(oli::sd-filter-display-table "AM-POST-FIX"  :column :Postfix  :test1 :greater :value1 " ")
(oli::sd-filter-display-table "AM-SUPER-FIX" :column :Superfix :test1 :greater :value1 " ")
(oli::sd-filter-display-table "AM-SUB-FIX"   :column :Subfix   :test1 :greater :value1 " ")  

;; The following functions define behavior during Import 2D, which
;; is also used for database loading:
;;(DOCU-CLEAR-TOP-PART-FOR-IMPORTED-SD-FILES   :ON)  ;;:OFF/:ON
;;(DOCU-CLEANUP-ON-ERROR-FOR-IMPORTED-SD-FILES :OFF) ;;:ON/:OFF

;; The following function defines whether Annotation use the 
;; build-in editor or an external editor specified with the global 
;; operating system variable EDITOR. 
;; (Please note, that the build-in editor allows to create 
;; 'special characters', f.e. the diameter sign
;;
;; (annotation-default-text-editor :build_in)  ;; or
;; (annotation-default-text-editor :external) 


;; SolidDesigner Annotation 9.0 (and newer) has the functionality to
;; automatically add centerlines and symmetrylines for geometry
;; derived from a cylinder. This happens within the update process.
;; Use the following function to activate / deactive this functionality
;; with respect to the different view types.

(docu_add_symlines_and_centerlines_to_views
   :standard_view  :ON      ; add to FRONT, TOP, RIGHT, LEFT, BOTTOM and BACK view
   :section_view   :ON      ; add to all kind of section views
   :detail_view    :ON      ; add to detail and partial views
   :isometric_view :OFF      ; add to isometric and general views
)
(AM_AUX_GEO_DEFAULT_SETTING :CEN_AUTO :ON :SYM_AUTO :ON)

;; *** Annotation Plot Settings : see am_plot_customize

;;Don't add diameter or thread fixes to single dimensions automatically
(AM_DIM_SET_A_PLACE :AUTOMATIC_FIXES "ON")

;;Use nearest point on source for reflines
;;(docu-set-rtl-nearest-mode :ON)

;;Hilite elements during BOM flag positioning 
;;(docu-set-current-bom-hilite-mode :ON)  ;; :ON (:OFF/T/nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Function (docu:docu-define-objects-to-be-used-in-bom)                       ;
; Parameter: :USE_CONTAINER_PARTS t/nil                                       ;
; With the help of this function it's possible to define if                   ;
; - anything located below a container                                        ;
;   or the container itself                                                   ;
; are included within the SCAN_BOM3D command of the Annotation BOM menu       ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(docu:docu-define-objects-to-be-used-in-bom
  :USE_CONTAINER_PARTS t)

;;Inverse Viewport Color
;(AM_VIEWPORT_COLOR :VIEWPORT_COLOR :RGB 0,0,1 :DONE :INVERT_ELEMENTS :ON)
(AM_VIEWPORT_COLOR :INVERT_ELEMENTS :ON) ;; colore della fv di Annotation (blu cobalto)


;;------------------------------------------------------------------------------------------------
(am_refl_settings
 :ref_arrow_size 3.5
 :ref_arrow_type 1
)

;;; *** Annotation Text Settings ***
(AM_TEXT_SETTINGS 
 :SIZE      3.5
 :SLANT     0.0
 :LINESP    2.2
)
;; (am_plot_ex :PATTERN_LENGTH :all 5.0 :accept) ;;
;; (AM_ISO_MODE :MODE "30")



;;; *** Annotation View Settings ***
;;; *** Annotation View Settings : Normal Lines ***     DIN/ISO 128-20 & -24
(AM_VIEW_NORMAL_LINES_PENSIZE  0.0)  ;; LINESIZE not usable for pen transformation !!!
;;; *** Annotation View Settings : Hidden Lines ***
(AM_VIEW_HIDDEN_LINE_PENSIZE   0.0)
;;; *** Annotation View Settings : Tangential Lines ***
(AM_VIEW_TAN_EDGES_PENSIZE     0.0)

;;UNITS=====================================================
;; reset to SD default units
(restore-user-units)
;;----------------------------------AGGIUNTA 14.01.08-------------------------
(AM_PLOT_EX
  :PLOT_WARNINGS      :ON  
  :PLOTTER_TYPE      :MSWINDOW_GDI_PRINTER 
  :PLOTTER_NAME      ;"HP LJ 5200 PCL6"
  :TO_FILE            :NO 
  :DESTINATION       "Prova" 
  :OVERWRITE         :NO 
  :PAPER_FORMAT      "A4"  
  :COPIES             1 
  :ORIENTATION       :PORTRAIT 
  :POSITION          :CENTER  
  :OUTPUT            :SHEET 
  :SCALE             :FIT 
  :CONTENTS          :VISIBLE 
)

(AM_PLOT_TRANSFORM :transf_name "UNIPI" :put_to_table :off) 

;(am_load_table "d:/programmi/cocreate/custom/14.50/user/annotation/unipi.fix")  
;(am_load_table "d:/programmi/cocreate/custom/14.50/user/annotation/unipi.hat")
;(am_load_table "d:/programmi/cocreate/custom/14.50/user/annotation/unipi.plt")
;(am_load_table "d:/programmi/cocreate/custom/14.50/user/annotation/unipi.tol")
;(am_load_table "d:/programmi/cocreate/custom/14.50/user/annotation/unipi.dms")  

;;--------------------------------------------
(docu-clear-view-profiles)

(docu-register-view-profile
  :name                           "Complex Single"
  :label                          "Singolo Complesso"
  :minimum-number-of-parts        1
  :maximum-number-of-parts        1
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :on
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)

(docu-register-view-profile
  :name                           "Simple Single" ;; same as 'Complex Single' but
                                                  ;; :update-view-immediately :on
  :label                          "Singolo Semplice"
  :minimum-number-of-parts        1
  :maximum-number-of-parts        1
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        '(:by_faces 300)
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :on
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)


(docu-register-view-profile
  :name                           "Small"
  :label                          "Piccolo Gruppo"
  :minimum-number-of-parts        2
  :maximum-number-of-parts        99
  :update-mode                    :classic
  :econofast                      :off
  :associativity-2d               :full
  :pressfit-handling              :default
  :clash-recognition              :default
  :update-view-immediately        :on
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :default
  :centerline-creation            :default
  :symmetryline-creation          :default
  :hidden-line-visible            :on
  :tangent-line-visible           :default
)

(docu-register-view-profile
  :name                           "Medium"
  :label                          "Gruppo Medio"
  :minimum-number-of-parts        100
  :maximum-number-of-parts        500
  :update-mode                    :graphics
  :facet-accuracy                 :medium
  :associativity-2d               :limited
  :pressfit-handling              :default
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-profile
  :name                           "Large"
  :label                          "Gruppo Grande"
  :minimum-number-of-parts        501
  :maximum-number-of-parts        999999
  :update-mode                    :graphics
  :facet-accuracy                 :low
  :associativity-2d               :limited
  :pressfit-handling              :off
  :clash-recognition              :off
  :update-view-immediately        :off
  :remove-small-parts             1.0
  :remove-library-parts           :on
  :remove-full-circles            0.5
  :remove-duplicate-hidden-lines  :on 
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-profile 
  :name                           "NC" 
  :label                          "NC"
  :update-mode                    :classic 
  :econofast                      :off 
  :associativity-2d               :full
  :pressfit-handling              :on
  :clash-recognition              :default
  :update-view-immediately        :on
  :remove-small-parts             0
  :remove-library-parts           :off
  :remove-full-circles            0
  :remove-duplicate-hidden-lines  :off 
  :thread-creation                :off
  :centerline-creation            :off
  :symmetryline-creation          :off
  :hidden-line-visible            :off
  :tangent-line-visible           :off
)

(docu-register-view-exception-profile 
  :name                           "Section" 
  :label                          "Sezione"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :section
  :centerline-creation            :on
  :symmetryline-creation          :on
  :hidden-line-visible            :on
  :tangent-line-visible           :off
)

(docu-register-view-exception-profile 
  :name                           "Detail" 
  :label                          "Dettaglio"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :detail
  :centerline-creation            :parent
  :symmetryline-creation          :parent
  :thread-creation                :parent
  :hidden-line-visible            :parent
  :tangent-line-visible           :parent
)

(docu-register-view-exception-profile 
  :name                           "Broken"
  :label                          "Interruzione"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :broken
  :centerline-creation            :on
  :symmetryline-creation          :on
  :thread-creation                :parent
  :hidden-line-visible            :parent
  :tangent-line-visible           :parent
)

(docu-register-view-exception-profile
  :name                           "Isometric Small" 
  :label                          "Isometric Small"
  :minimum-number-of-parts        0
  :maximum-number-of-parts        999999
  :view-type                      :general
  :centerline-creation            :off
  :symmetryline-creation          :off
  :thread-creation                :off
)

(docu-register-view-exception-profile 
  :name                           "Isometric Large" 
  :label                          "Isometric Large"
  :minimum-number-of-parts        10
  :maximum-number-of-parts        999999
  :view-type                      :general
  :update-mode                    :graphics
  :facet-accuracy                 :low
)

;;; *** Annotation View Settings ***
;;; *** Annotation View Settings : Normal Lines ***     DIN/ISO 128-20 & -24
(AM_VIEW_PART_COLOR            :OFF)
(AM_VIEW_NORMAL_LINES_COLOR    :RGB 1.0,1.0,1.0 :DONE)
(AM_VIEW_NORMAL_LINES_LTYPE    :SOLID)
;;; *** Annotation View Settings : Hidden Lines ***
(AM_VIEW_HIDDEN_LINE_DISPLAY   :ON)
(AM_VIEW_HIDDEN_LINE_COLOR     :RGB 1.0,1.0,1.0 :DONE)
(AM_VIEW_HIDDEN_LINE_LTYPE     :INVISIBLE)
;;; *** Annotation View Settings : Tangential Lines ***
(AM_VIEW_TAN_EDGES_COLOR       :RGB 0.0,0.0,1.0 :DONE)
(AM_VIEW_TAN_EDGES_LTYPE       :SOLID)

(config-section
 :docu_section_line_geo_ltype        'LT_DOT_CENTER ;;or 'LT_SOLID
                                                    ;;   'LT_DASHED
                                                    ;;   'LT_LONG_DASHED
                                                    ;;   'LT_DASH_CENTER
                                                    ;;   'LT_PHANTOM
                                                    ;;   'LT_CENTER_DASH_DASH
                                                    ;;   'LT_DOTTED
 :docu_section_line_geo_color        '(RGB 255 0 0)

 :docu_section_line_segm_ltype       'LT_SOLID      ;; see above
 :docu_section_line_segm_color       '(RGB 0 255 0)

 :docu_section_line_leader_ltype     'LT_SOLID      ;; see above
 :docu_section_line_leader_color     '(RGB 255 255 0) ;; 'WHITE

 ;; The following settings define the label on each side of the
 ;; section line
 :docu_section_line_label_font       "hp_i3098_v"
 :docu_section_line_label_font_2byte "hp_kanji_c"
 :docu_section_line_label_filled     'ON           ;;or 'OFF
 :docu_section_line_label_ratio      '1.0
 :docu_section_line_label_color      '(RGB 255 255 0)
 :docu_section_line_label_frame      'FLAG ;;'OFF           ;;or 'BOX
                                                    ;;   'BALLOON
                                                    ;;   'FLAG
 :DOCU_SECTION_LINE_LABEL_POSITION  'BOTTOM_SIDE  ;;'TOP_SIDE    'TOP  

 ;; The following settings define the label below the section view
 :docu_section_view_label_font       "hp_i3098_v"
 :docu_section_view_label_font_2byte "hp_kanji_c"
 :docu_section_view_label_filled     'ON           ;;or 'OFF
 :docu_section_view_label_ratio      '1.0
 :docu_section_view_label_color      '(RGB 255 255 0)
 :docu_section_view_label_frame      'OFF           ;;or 'BOX
                                                    ;;   'BALLOON
                                                    ;;   'FLAG
 :docu_section_view_label_position   'BELOW         ;;or 'ABOVE
 :docu_section_view_label_includes_scaling_info 'AUTOMATIC  ;; or 'NO or 'YES

 ;; The following settings define the inner edges of a section view
 :inner-attributes-color             '(OLI::SD-RGB-TO-COLOR 1.0,0.0,1.0)
                                                    ;;or 'GREEN 
 :inner-attributes-linetype          'LT_PHANTOM    
 :inner-attributes-linewidth         '0.0

 :docu_only_last_section_visible_in_dependant_views 'NO     ;; or 'YES
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The following section define the labels for details, partials and cutaways
(config-detail 
 ;;The following settings define the detail/cutaway border
 :docu_detail_border_ltype                 'LT_SOLID 
 :docu_detail_border_color                 '(RGB 255 0 0) ;;'WHITE
 :docu_cutaway_border_visible              'NO ;; or 'YES     
 :docu_cutaways_visible_in_dependant_views 'NO;; or'YES      15.01.2007

 ;; The following settings define the label below the detail/cutaway border
 :docu_detail_label_font                  "hp_i3098_v"
 :docu_detail_label_font_2byte            "hp_kanji_c" 
 :docu_detail_label_filled                'ON           ;;or 'OFF
 :docu_detail_label_size                  '3.5
 :docu_detail_label_ratio                 '1.0
 :docu_detail_label_color                 '(RGB 255 255 0 )
 :docu_detail_label_frame                 'OFF

 ;; The following settings define the label below the detail/partial view
 :docu_detail_view_label_font                  "hp_i3098_v"
 :docu_detail_view_label_font_2byte            "hp_kanji_c" 
 :docu_detail_view_label_filled                'ON           ;;or 'OFF
 :docu_detail_view_label_ratio                 '1.0
 :docu_detail_view_label_color                 '(RGB 255 255 0)
 :docu_detail_view_label_frame                 'OFF
 :docu_detail_view_label_includes_scaling_info 'YES       ;; or 'AUTOMATIC
                                                          ;; or 'NO 
 :docu_detail_view_label_position              'BELOW         ;;or 'ABOVE

 ;; The following settings define the appearance of the border elements 
 ;; within the detail /partial view 
 :docu_detail_border_edge_ltype                'LT_SOLID ;;'LT_DOTTED
 :docu_detail_border_edge_color                '(OLI::SD-RGB-TO-COLOR 1.0,0.0,0.0) ;;'CYAN
 :docu_partial_border_edge_ltype               'LT_SOLID ;;'LT_DOTTED
 :docu_partial_border_edge_color               '(OLI::SD-RGB-TO-COLOR 1.0,0.0,0.0) ;;'CYAN
 :docu_cutaway_border_edge_ltype               'LT_SOLID ;;'LT_DOTTED
 :docu_cutaway_border_edge_color               '(OLI::SD-RGB-TO-COLOR 1.0,0.0,0.0) ;;'CYAN
 :docu_broken_border_edge_ltype                'LT_SOLID ;;'LT_DOTTED
 :docu_broken_border_edge_color                '(OLI::SD-RGB-TO-COLOR 1.0,0.0,0.0) ;;'CYAN
 :docu_broken_border_edge_pattern_type         :zigzag
 :docu_partial_use_docuplane_name_for_label    :NO
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; The following section define the labels below standard, flat and general views
(config-view-labels
 :docu_view_label_font                  "hp_i3098_v"
 :docu_view_label_font_2byte            "hp_kanji_c" 
 :docu_view_label_filled                'ON           ;;or 'OFF
 :docu_view_label_ratio                 '1.0
 :docu_view_label_color                 '(RGB 0 0 255)
 :docu_view_label_frame                 'OFF
 :docu_view_label_includes_viewname     'YES           ;; or 'NO 
 :docu_view_label_includes_scaling_info 'AUTOMATIC     ;; or 'NO
                                                       ;; or 'YES
 :docu_view_label_position              'BELOW         ;;or 'ABOVE
)

(config-scale-info-within-view-labels
 :docu_view_label_scaling_syntax        'COLON_SYNTAX  ;;or 'SLASH_SYNTAX
                                                       ;;or 'DECIMAL_SYNTAX
                                                       ;;or 'X_SYNTAX
 :docu_view_label_scaling_brackets      'ROUND_BRACKETS ;;or 'NONE          
                                                       ;;or 'SQUARE_BRACKETS
                                                       ;;or 'BRACE
)


( am_symbol_settings :type "TOLERANCE"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "TARGET_AREA"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "DATUM"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "DATUM_RTL"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "DATUMT"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
;;( am_symbol_settings :type "GENERIC"
;;  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "TOLERANCE"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "SURFACE"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)
( am_symbol_settings :type "WELDING"
  :text_color  41215 :done  :geo_color   33023 :done :hatch_color 33023 :done)



;;; *** Annotation Hatch Settings : Mode ***
(AM_HATCH_MODE
 :ANGLE_REFERENCE :BY_VIEW
 :DIST_SCALE      :BY_VIEW
 :NEW_HATCHES     :COPY_VARIATE
 :VARIATE_ANGLE   2
 :VARIATE_DIST    0.707
 :SYNCHRONICITY   :PARTS
)

(am_hatch_default
  :color (oli::sd-rgb-to-color 1.0,0.0,1.0) :DONE
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(am_mbp_settings
  :circle_size  1.0
  :circle_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :circle_linetype :PHANTOM
  :circle_pensize  0.0
  :lines_size   1.5
  :lines_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :lines_linetype :SOLID
  :lines_pensize 0.0
  :extension_color (oli::sd-rgb-to-color 1.0,0.0,1.0) :done
  :extension_linetype :PHANTOM
  :extension_pensize 0.0
  :lost_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :automatic_update
)
(docu::docu-reset-drawing-modified-flag)

(am_thread_settings
  :color (oli::sd-rgb-to-color 1.0,0.0,1.0) :done
  :ltype :SOLID
  :pen_size 0.0
  :ltype_hidden :DASHED
  :pen_size_hidden 0.0
)

(am_aux_geo_default_setting
  :cen_abs_offset 0.0
  :cen_rel_offset 0.1
  :cen_line_type  4
  :cen_pensize    0.0
  :cen_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
  :sym_offset     0.0
  :sym_line_type  4
  :sym_pensize    0.0
  :sym_color (oli::sd-rgb-to-color 1.0,0.0,0.0) :done
)

(am_refl_settings
 :ref_source_gap 0.0
 :ref_dest_gap   0.0
 :ref_line_type  1
 :ref_color (oli::sd-rgb-to-color 1.0,0.0,1.0) :done
 :ref_pen_size   0.0
)

;;; *** Annotation Text Settings ***
(AM_TEXT_SETTINGS 
 :ABS_ANGLE 0.0 
 :ADJUST    1
 :FRAME     "OFF" 
 :FILLED    "ON"
 :RATIO     1.0 
 :FONT1B    "hp_i3098_v"
 :FONT2B    "hp_kanji_c" 
 :COLOR     (oli::sd-rgb-to-color 1.0,1.0,0.0) :DONE
 :FEEDB     "TF_TEXT" 
)



;;----------------------

(display "*** Caricato senza errori***")
(display  " ")
(display  " ")
(display "---------> RICORDA CHE IL BLU NON VIENE STAMPATO! <---------")

