(in-package  :my-special-bom-attr)
(use-package '( :oli ))

;;-----------------------------------------------------------------------------
;; Definizione degli attributi da estrarre dalla parte automaticamente
;;-----------------------------------------------------------------------------

;Definizione del nome della parte (Campo Descrizione) variabile Part-name
(defun my-bom-attr-part-name (selitem)
  (let ((contents-name (oli::sd-inq-obj-basename selitem)))
    (if contents-name contents-name (oli::sd-inq-obj-basename selitem))
  )    
)

;Definizione del ID Contenuto (Campo Codice) variabile Part-no
(defun my-bom-attr-part-no (selitem)
  (let ((contents-name (oli::sd-inq-obj-contents-name selitem)))
    (if contents-name contents-name "")
  )    
)


;Definizione  delle Proprieta' inserite manualmente
;----------------------------------------------------

;Definizione della Descrizione - variabile descrizione
(defun bomattr-get-descrizione (object)
 (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR"
                                    :values :attachment :contents)))
    (if attr (getf attr :descrizione) nil)
 )
)


;Definizione del Peso - variabile Peso
(defun bomattr-get-peso (object)
 (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR"
                                    :values :attachment :contents)))
    (if attr (getf attr :peso) nil)
 )
)


;Materiale - variabile material
(defun bomattr-get-material (object)
  (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR" 
                                     :values :attachment :contents)))
    (if attr (getf attr :material) nil)
  )
)

;;-----------------------------------------------------------------------------
;; Definizione del menu' per l'inserimento delle proprieta'
;;-----------------------------------------------------------------------------

(sd-defdialog 'my_special_bom_attr
  :dialog-title   "Proprieta'"
  :start-variable 'object
  :variables 
  '(
    (OBJECT 
      :value-type    :part-assembly
      :modifies      :contents
      :title         "Part/Assy"
      :prompt-text   "Seleziona una parte o un assieme."
      :after-input   
       (progn
         (setq material (bomattr-get-material object))
         (setq peso   (bomattr-get-peso   object))
	   (setq descrizione   (bomattr-get-descrizione   object))
         
      )
    )

   (MATERIAL 
      :range     ( "S235 JR UNIEN10025" 
			"S275 JR UNEN10025" 
			"C40 UNI7845" 
			"C45 UNI7845" 
			"CuSn10Pb10 UNI7013"
			"39NiCrMo3 UNI EN10083"
			"X5CrNiMo1712 UNI6900"
			"Aisi 304"
			"Ghisa 20"
			"Alluminio" "Bronzo" "Ottone" "Rame" "Teflon" "Policarbonato" "Gomma" "PVC" )
      :title         "Materiale"
      :prompt-text   "Inserire il materiale"
    )
   
   (PESO
      :value-type    :number
      :title         "Peso"
      :prompt-text   "Inserire il Peso della Parte"
      :initial-value  0
    )

	(DESCRIZIONE
      :value-type    :string
      :title         "Descrizione"
      :prompt-text   "Inserire la descrizione della Parte"
      :initial-value  nil
      
   )	
)

  :ok-action 
  '(progn
          (sd-attach-item-attribute object "MY_SPECIAL_BOM_ATTR"
                               :attachment :contents
                               :on-copy    :copy
                               :on-merge   :maintain
                               :on-split   :copy
                               :on-xform   :maintain
                               :filing     '(:sd-file)  
                               :values     
                                           `(
                                            :descrizione  ,descrizione
					    :material    ,material
                                            :peso      ,peso
							                                             )
     )
   )
)

;;----------------------------------------------------------------------------
;; Definizione degli attributi della BOM
;;----------------------------------------------------------------------------

(if (OLI::sd-module-active-p "ANNOTATION")
   (progn
  
(defun bomattr-get-descrizione (selitem)
  (let ((attr (sd-inq-item-attribute selitem "MY_SPECIAL_BOM_ATTR"
                                     :values :attachment :contents)))
    (if attr (getf attr :descrizione) nil)
  )
)

(defun bomattr-get-material (selitem)
  (let ((attr (sd-inq-item-attribute selitem "MY_SPECIAL_BOM_ATTR"
                                     :values :attachment :contents)))
    (if attr (getf attr :material) nil)
  )
)


(defun bomattr-get-peso (selitem)
  (let ((attr (sd-inq-item-attribute selitem "MY_SPECIAL_BOM_ATTR" 
                                     :values :attachment :contents)))
     (if attr (getf attr :peso) nil)
  )
)


;;-----------------------------------------------------------------------------
;; Definizione della BOM da compilare
;;-----------------------------------------------------------------------------

(defun my-bom-attr-descrizione (selitem)
  (let ((descrizione (bomattr-get-descrizione selitem)))
    (if descrizione descrizione "")
  )
) 

(defun my-bom-attr-material (selitem)
  (let ((material (bomattr-get-material selitem)))
    (if material material "")
  )
) 

(defun my-bom-attr-peso (selitem)
  (let ((peso (bomattr-get-peso selitem)))
    (if peso peso "")
  )    
)


(docu::docu-unregister-bom-attr-all)

(docu::docu-register-bom-attr :attr-type      "DOCU_BOM_QUANTITY" 
                              :attr-title     "Qt"
                              :attr-display   t
                              :attr-value-fnc nil)   ;; system bom attribute

(docu::docu-register-bom-attr :attr-type      "PART_NAME"
                              :attr-title     "Denominazione"
                              :attr-display   t
                              :attr-value-fnc #'my-bom-attr-part-name)

(docu::docu-register-bom-attr :attr-type      "PART_NO"
                              :attr-title     "Codice"
                              :attr-display   t
                              :attr-value-fnc #'my-bom-attr-part-no)

(docu::docu-register-bom-attr :attr-type      "DESCRIZIONE"
                              :attr-title     "Descrizione"
                              :attr-display   t
                              :attr-value-fnc #'my-bom-attr-descrizione)

(docu::docu-register-bom-attr :attr-type      "MATERIAL"
                              :attr-title     "Materiale"
                              :attr-display   t
                              :attr-value-fnc #'my-bom-attr-material)

(docu::docu-register-bom-attr :attr-type      "PESO"
                              :attr-title     "Peso"
                              :attr-display   t
                              :attr-value-fnc #'my-bom-attr-peso)


;;-----------------------------------------------------------------------------
;; File collegati: bomc_usr.mi bomh_usr.mi e cartigli
;;-----------------------------------------------------------------------------

	)
)
