;;-----------------------------------------------------------------------------
;; Macro per la creazione di una BOM personalizzata 
;; Versione 2.0 17/07/02	Autore: Stefano Parducci
;;-----------------------------------------------------------------------------

(in-package  :my-special-bom-attr)
(use-package '( :oli ))

;;-----------------------------------------------------------------------------
;; Definizione degli attributi da estrarre dalla parte automaticamente
;;-----------------------------------------------------------------------------

;Definizione del nome della parte (Campo Descrizione) variabile Part-name
(defun my-bom-attr-part-name (selitem)
  (let ((contents-name (oli::sd-inq-obj-basename selitem)))
    (if contents-name contents-name (oli::sd-inq-obj-basename selitem))
  )    
)

;Definizione del ID Contenuto (Campo Codice) variabile Part-no
(defun my-bom-attr-part-no (selitem)
  (let ((contents-name (oli::sd-inq-obj-contents-name selitem)))
    (if contents-name contents-name "")
  )    
)


;Definizione  delle Proprieta' inserite manualmente
;----------------------------------------------------

;Definizione della Descrizione - variabile descrizione
(defun bomattr-get-descrizione (object)
 (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR"
                                    :values :attachment :contents)))
    (if attr (getf attr :descrizione) nil)
 )
)


;Definizione del Peso - variabile Peso
(defun bomattr-get-peso (object)
 (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR"
                                    :values :attachment :contents)))
    (if attr (getf attr :peso) nil)
 )
)


;Materiale - variabile material
(defun bomattr-get-material (object)
  (let ((attr (sd-inq-item-attribute object "MY_SPECIAL_BOM_ATTR" 
                                     :values :attachment :contents)))
    (if attr (getf attr :material) nil)
  )
)

;;-----------------------------------------------------------------------------
;; Definizione del menu' per l'inserimento delle proprieta'
;;-----------------------------------------------------------------------------

(sd-defdialog 'my_special_bom_attr
  :dialog-title   "Proprieta'"
  :start-variable 'object
  :variables 
  '(
    (OBJECT 
      :value-type    :part-assembly
      :modifies      :contents
      :title         "Part/Assy"
      :prompt-text   "Seleziona una parte o un assieme."
      :after-input   
       (progn
         (setq material (bomattr-get-material object))
         (setq peso   (bomattr-get-peso   object))
	   (setq descrizione   (bomattr-get-descrizione   object))
         
      )
    )

   (MATERIAL 
      :value-type    :string
      :title         "Materiale"
      :prompt-text   "Inserire il materiale"
      :initial-value nil
    )
   
   (PESO
      :value-type    :number
      :title         "Lungh"
      :prompt-text   "Inserire il Peso della Parte"
      :initial-value  0
    )

	(DESCRIZIONE
      :value-type    :string
      :title         "Descrizione"
      :prompt-text   "Inserire la descrizione della Parte"
      :initial-value  nil
      
   )	
)

  :ok-action 
  '(progn
          (sd-attach-item-attribute object "MY_SPECIAL_BOM_ATTR"
                               :attachment :contents
                               :on-copy    :copy
                               :on-merge   :maintain
                               :on-split   :copy
                               :on-xform   :maintain
                               :filing     '(:sd-file)  
                               :values     
                                           `(
                                            :descrizione  ,descrizione
					    :material    ,material
                                            :peso      ,peso
							                                             )
     )
   )
)


